module SimpleTabuleiro where

--posico linhas, valor coluna
type TabuleiroDamas = [Int]

lerTab :: Int -> TabuleiroDamas -> String
lerTab 1 tab= "(1"  ++ "," ++ show (tab!!(0)) ++ ")\n"
lerTab n tab = (lerTab (n-1) tab) ++ "(" ++show n ++ "," ++ show (tab!!(n-1)) ++ ")\n" 
	
criaTabuleiro :: Int -> TabuleiroDamas
criaTabuleiro n = [ (-n) | x<-[1..n]]
 
posLinha :: Int-> Int -> TabuleiroDamas -> TabuleiroDamas
posLinha linha coluna tab =	(take (linha-1) tab) ++ [coluna] ++ (drop linha tab)

testaColuna :: Int -> TabuleiroDamas -> Bool
testaColuna coluna tab = notElem coluna tab

testaDiagonal :: Int -> Int -> Int -> TabuleiroDamas -> Bool
testaDiagonal linha coluna n tab 
	=([x | x<-([1..linha-1] ++ [linha+1..n]), ((equacao1 x) > 0 && (equacao1 x) <= n) && (tab !!  (x-1) == equacao1 (x))] == []) &&
	 ([x | x<-([1..linha-1] ++ [linha+1..n]), ((equacao2 x) > 0 && (equacao2 x) <= n) && (tab !!  (x-1) == equacao2 (x))] == [])
	where 
		equacao1 y = ( y + coluna - linha)
		equacao2 y = (-y + coluna + linha)
		
procuraSolucao :: Int-> Int -> Int -> TabuleiroDamas -> TabuleiroDamas
procuraSolucao lin col n tab
	|lin == 1 && col > n = error "Por uma Thread nao tem solucao"
	|lin > n = tab
	|col > n = procuraSolucao (lin-1) ( 1 + (tab!!(lin-2)) ) n (posLinha lin (-n) tab)
	|testaColuna col tab && testaDiagonal lin col n tab= (procuraSolucao (lin+1) 1 n (posLinha lin col tab))
	|otherwise = procuraSolucao lin (col+1) n tab
		
-- x = criaTabuleiro 4
-- y = posLinha 1 3 x
-- z= testaDiagonal 2 4 4 y

-- k = procuraSolucao 1 1 4 x 