module QuickSortThread where
import Control.Parallel
import QuickSortSimple
import Control.Concurrent
import Control.Concurrent.MVar

quickSortT :: Ord a => MVar[a] -> MVar Int -> Int -> IO()
quickSortT listaMVar x n= 
	do
		lista <- takeMVar listaMVar
		let a= head lista
		let resto = tail lista
		
		let	esq = [x | x<-resto, x<=a]
		let	dir = [x | x<-resto, x>a]
			
		if (n>1) then do
			esqT <- newMVar esq
			dirT <- newMVar dir
			vazia1 <- newEmptyMVar
			vazia2 <- newEmptyMVar
						
			forkIO (quickSortT esqT vazia1 $ n-1)
			forkIO (quickSortT dirT vazia2 $ n-1)
			
			takeMVar vazia1
			takeMVar vazia2
			
			lerEsq <- readMVar esqT
			lerDir <- readMVar dirT
			
			putMVar listaMVar $ lerEsq ++ [a] ++ lerDir
			
			return ()
		else do
			putMVar listaMVar $ quickSort lista
			return ()
			
		putMVar x 0

