module Main where
import Control.Parallel
import System.Random
import System.IO
import Control.Concurrent
import Control.Concurrent.MVar

main =
	do
		putStrLn "Digite o tamanho da fila"
		tamF <- getLine
		putStrLn "Digite o numero maximo de clientes atendidos"
		maxC <- getLine
		numAtual <- newMVar 0
		fila <- newMVar []
		forkIO(caixaAtende fila numAtual (read maxC))
		forkIO(caixaAtende fila numAtual (read maxC))
		forkIO(caixaAtende fila numAtual (read maxC))
		forkIO( clienteChega fila (read tamF) 1)
		
		loopInf numAtual (read maxC)
		putStrLn "Fim"
		--getLine
		
type Cliente = Int
type Fila = [Int]

loopInf :: MVar Int -> Int -> IO()
loopInf cond n =
	do
		x<- readMVar cond
		if (x<n) then
			loopInf cond n
		else
			return ()

clienteChega :: MVar Fila -> Int -> Cliente -> IO()
clienteChega filaMVar  n id =
	do
		time <- randomRIO (50000,500000)
		threadDelay time
		fila <- takeMVar filaMVar
		let tamanho = length fila
		if (tamanho < n) then do
				let f = addFila fila id
				putMVar filaMVar f
				putStrLn $ (show id) ++ ", cliente chegou."
				clienteChega filaMVar n (id + 1)
		else do
			putMVar filaMVar fila
			clienteChega filaMVar n id

caixaAtende :: MVar Fila -> MVar Int -> Int-> IO()
caixaAtende filaMVar totalMVar max= 
	do
		threadDelay 1000000
		total <- readMVar totalMVar
		if (total < max) then do
			fila <- takeMVar filaMVar
			let tamanho = length fila
			if (tamanho > 0) then do
				x<-takeMVar totalMVar
				let f = removeFila fila
				putMVar totalMVar (x+1)
				putMVar filaMVar f
				putStrLn $ (show (x+1)) ++ " clientes atendidos."
				caixaAtende filaMVar totalMVar max
			else do
				putMVar filaMVar fila
				caixaAtende filaMVar totalMVar max
		else do
			z <- takeMVar totalMVar
			return ()
			
addFila :: Fila -> Cliente -> Fila
addFila [] x = [x]
addFila fila x = fila ++ [x]

removeFila :: Fila -> Fila
removeFila [] = []
removeFila (a:fila) = fila

cliente :: MVar Cliente -> IO()
cliente cMVar = return ()