module Main where
import Control.Parallel
import System.Random
import System.IO
import Control.Concurrent
import Control.Concurrent.STM
import Data.List

type Cadeiras = TVar [String]

main =
	do
		let lista = ["Marcelo", "Joao", "Igor", "Folha", "Japa"]
		let n = length lista
		criancas <- atomically (newTVar lista)
		cadeiras <- atomically (newTVar $ novasCadeiras n)
		teste <- atomically (readTVar cadeiras)
		contador <- atomically (newTVar $ n-1)
		comeca lista cadeiras contador (n-1)
		putStrLn "<<FIM>>"
		
novasCadeiras :: Int -> [String]
novasCadeiras 1 = []
novasCadeiras n = "\0" : (novasCadeiras $ n-1)

--terceiro comecando em 0
removeByIndex :: Eq a => [a] -> Int -> Int -> [a]
removeByIndex [] _ _= []
removeByIndex (a:as) n y
	| n/=y = a:(removeByIndex as n (y+1))
	| otherwise = as 
	
putByIndex :: Eq a => [a]-> a -> Int -> Int -> [a]
putByIndex [] _ _ _= []
putByIndex (a:as) putN n y
	| n/=y = a:(removeByIndex as n (y+1))
	| otherwise = putN:as

tentaPegar :: String -> Cadeiras -> Int-> TVar Int-> STM(Bool, Int)
tentaPegar nome cadeiras pos cont=
	do
		cad <- readTVar cadeiras
		i <- readTVar cont
		
		let aux = cad !! (pos)
		if (aux == "\0") then do
			let newList = nome : (removeByIndex cad pos 0)
			writeTVar cadeiras newList
			writeTVar cont (i-1) 
			return (True, i-1)
		else
			return (False, i)

sThreads ::	 [String] -> Cadeiras -> TVar Int->Int -> IO()
sThreads [] _ _ _ = return ()
sThreads (a:nomes) cadeiras cont n =
	do
		forkIO(cThread a cadeiras n cont)
		sThreads nomes cadeiras cont n

cThread :: String -> Cadeiras -> Int -> TVar Int -> IO()
cThread nome cadeiras n cont=
	do
		x <- randomRIO(0,(n-1))

		(res, i) <- atomically ( tentaPegar nome cadeiras x cont)

		if (res) then
			return ()
		else
			if (i>0) then
				cThread nome cadeiras n cont		
			else
				return ()
				
checaContador :: TVar Int -> IO()
checaContador cont =
			do
				x<- atomically $ readTVar cont
				if (x > 0) then
					checaContador cont
				else
					return ()
		
		
sobrou :: [String] -> [String] -> String
sobrou l1 l2 = head [x | x<-l1, not $ x `elem` l2]

	
comeca :: [String] -> Cadeiras -> TVar Int->Int -> IO()
comeca nomes cadeiras cont n =
	do
	
		sThreads nomes cadeiras cont n
		
		checaContador cont
		
		(newNomes, novasCadeiras) <- atomically ( 
			do 
				a<-readTVar cadeiras
				b <- newTVar $ novasCadeiras $ n
				writeTVar cont (n-1)
				return (a,b)
				) 

		putStrLn $ (sobrou nomes newNomes) ++ " saiu."
		if ((n-1) == 0) then
			putStrLn $ (sobrou nomes [sobrou nomes newNomes]) ++ " ganhou!"
		else do
			comeca newNomes novasCadeiras cont (n-1)
		