module Main where
import System.Random
import System.IO
import Control.Concurrent
import Control.Concurrent.STM

main =
	do
		putStrLn "Digite o tamanho da fila de espera"
		tam <- getLine
		let n = read tam
		putStrLn "Informe o tempo de duracao do servidor (em segundos)"
		t<- getLine 
		let tempo = read t
		
		contFila <- atomically $ newTVar 0
		contJogador <- atomically $ newTVar 0
		contPartidas <- atomically $ newTVar 0
		
		forkIO (novoJogador contJogador contFila n)
		forkIO (criaPartida contPartidas contFila)
		
		threadDelay $ tempo*1000000
		
		nPartidas <- atomically $ readTVar contPartidas
		nJogadores <- atomically $ readTVar contJogador

		putStrLn $ "Foram criadas " ++ (show nPartidas) ++ " partidas"
		putStrLn $ "Porem " ++ (show nJogadores) ++ " jogaram paciencia"
		
novoJogador :: TVar Int -> TVar Int -> Int-> IO()
novoJogador contador fila n =
	do
		fator <- randomRIO (1,2)
		let tempo = fator*60000
		threadDelay tempo	
		x<- atomically ( 
				do
					ant <-readTVar contador
					antFila <- readTVar fila
					
					if (antFila < n) then do
						writeTVar fila (antFila +1)
						return True
					else do
						writeTVar contador (ant+1)
						return False
			)	
		if x then
			putStrLn "Jogador ira jogar domino"
		else
			putStrLn "Jogador ira jogar paciencia"
		novoJogador contador fila n
	
criaPartida :: TVar Int -> TVar Int -> IO()
criaPartida contador fila =
	do
		threadDelay 500000
		
		x<- atomically (
				do
					partidas<- readTVar contador
					antFila<- readTVar fila
					if (antFila >= 4) then do
						writeTVar contador $ partidas + 1
						writeTVar fila $ antFila - 4
						return (True)
					else
						return (False)
			)
		
		if x then
			putStrLn "Partida criada"
		else
			return ()
		
		criaPartida contador fila