module Main where
import System.Random
import System.IO
import Control.Concurrent
import Control.Concurrent.MVar

main =
	do
		putStrLn "Digite o numero de mesas"
		a<- getLine
		let numMesas = read a
		putStrLn "Digite do numero de pessoas"
		b<- getLine
		let numLeitores = read b
		putStrLn "Digite o tempo (em segundos) de duracao"
		c<- getLine
		let tempo = read c
		
		mesas <- criaMesas numMesas
		contLivros <- newMVar 0
		
		forkIO $ razel mesas numMesas 0 contLivros
		leitoresPegam mesas numLeitores (numMesas-1)
		
		threadDelay $ 1000000*tempo
		
		totalLidos <- takeMVar contLivros
		
		putStrLn $ "Total de livros retornados: " ++ (show totalLidos)
		
criaMesas :: Int -> IO ([MVar Int])
criaMesas 0 = return []
criaMesas n =
	do
		novo <- newMVar 0
		resto <- aux
		return (novo:resto)
		where aux = criaMesas $ n-1
		
isJust :: Maybe a -> Bool
isJust (Just _) = True
isJust _ = False
		
getJust :: Maybe a -> a
getJust (Just x) = x 
		
razel :: [MVar Int] -> Int ->Int -> MVar Int->IO()
razel mesas n nAtual contador =
	do
		let mesa = mesas !! nAtual
		
		aux <- tryTakeMVar mesa
		if (isJust aux) then do
			let x = getJust aux

			if (x > 0) then do

				antLivro <- takeMVar contador
				putMVar contador (antLivro + x)
				putMVar mesa 0
			else do
				return ()
				putMVar mesa 0
			
		else
			return ()
			
		razel mesas n ((nAtual+1) `mod` n) contador

leitoresPegam :: [MVar Int] -> Int ->Int  -> IO()
leitoresPegam _ 0 _  = return ()
leitoresPegam mesas cont numMesas =
	do
		forkIO $ leitorPega mesas $ numMesas
		leitoresPegam mesas (cont-1) numMesas
		
leitorPega :: [MVar Int] -> Int -> IO()
leitorPega mesas n =
	do
		
		nMesa <- randomRIO(0,n)
		nLivros <- randomRIO(1,10)
		
		let mesa = mesas !! nMesa
		aux <- tryTakeMVar mesa
		if (isJust aux) then do
			let x= getJust aux
		--	putStrLn $ "Leitor " ++ (show x)
			if (x == 0) then do

				threadDelay $ 2000000*nLivros
				putStrLn $ show nLivros
				putMVar mesa nLivros
			else
				putMVar mesa x
		else
			return ()
		leitorPega mesas n
